classdef CAmplifier < CDevice
    %CAMPLIFIER NiHu.Lab class for Amplifier handling
    %
    % Example:
    %  Amp = CAmplifier('PCB', '4228A', 1234, 8, true, [1 10 100]);
    %  AmpCh = CAmpChannel(Amp, 1, 10);
    %  AmpCh.PushButton();
    %
    % See also: CAmpChannel, CDevice
    
    properties (Constant)
        None = CAmplifier('Empty', '', 0, 1, false, 1);
    end
    
    properties (SetAccess = immutable)
        NumChannels     % number of channels
        provideICP      % logical, true if amplifier can provide ICP current
        Amplifications  % list of achievable amplifications
    end
    
    methods
        function obj = CAmplifier(vendor, model, sn, nch, provICP, amps)
            %CAMPLIFIER constructor
            
            obj = obj@CDevice(vendor, model, sn);
            obj.NumChannels = nch;
            obj.provideICP = provICP;
            obj.Amplifications = amps;
        end
    end % of public methods
end % of classdef

