classdef CDevice < handle
    %CDEVICE NiHu.Lab class for Device handling
    
    properties (SetAccess = immutable, GetAccess = protected)
        Model
        SerialNr
    end
    
    properties (SetAccess = immutable)
        Vendor
    end
    
    properties (Dependent = true)
        Name        % Name of the Sensor (vendor model sn)
    end
    
    methods
        function obj = CDevice(vendor, model, sn)
            obj.Vendor = vendor;
            obj.Model = model;
            obj.SerialNr = sn;
        end
        
        function name = get.Name(obj)
            name = strtrim(sprintf('%s %s SN%d', obj.Vendor,...
                obj.Model, obj.SerialNr));
        end
    end
end