classdef CHardwareView < CPanel & CGuiView
    %CHARDWAREVIEW NiHu.Lab class for displaying Hardware status
    
    properties (Access = private)
        tInfo
        hBar
    end
	
    methods
        function obj = CHardwareView(parent, hData)
            %CHARDWAREVIEW constructor
            
            obj = obj@CPanel(parent, 'HARDWARE_STATUS_PANEL');
            obj = obj@CGuiView(hData, {'nSamplesInBuffer'});
            obj.InitObject();
            obj.refresh();
        end
        
        function refresh(obj)
            %REFRESH called when underlying data is changed
            
            set(obj.hBar, 'YData', obj.hData.nSamplesInBuffer);
        end
    end % of public methods

    methods (Access = private)
        function InitObject(obj)
            obj.tInfo = uicontrol('parent', obj.hPanel, 'Style', 'Text', ...
                'String', '', 'Position', [0 0 14 14]);
            hAx = axes('Parent', obj.hPanel, 'Units', 'pixels',...
                'ActivePositionProperty', 'Position', ...
                'Position', [0, 0, 100, 14],...
                'NextPlot', 'ReplaceChildren');
            obj.hBar = barh(hAx, 0, 'FaceColor', 'blue');
            xlim(hAx, [0 obj.hData.DMADepth]);
            set(hAx, 'XTick', [], 'YTick', []);
            
            l = {{obj.tInfo, [0 0]} {hAx, [-1 0]}};
            GuiLayout.ApplyLayout(obj.hPanel, l);
        end
    end % of private methods
end % of classdef
