classdef CMultiAmpSetter < handle
    %CMULTIAMPSETTER Class to set amplification of mutliple amplifiers

    properties
        Channels
        Amps
        AmpSetters
    end
    
    methods
        function obj = CMultiAmpSetter(channels)
            obj.Channels = channels(cell2mat({channels.isSelected}));
            obj.getAmps();
            if ~isempty(obj.Amps)
                obj.InitFigure();
            end
        end
    end
    
    methods (Access = private)
        function getAmps(obj)
            obj.Amps = CAmplifier.empty(1,0);
            for i = 1 : length(obj.Channels)
                obj.Amps = unique([obj.Amps, obj.Channels(i).AmpCh.Amplifier]);
            end
            obj.Amps = obj.Amps(obj.Amps ~= CAmplifier.None);
        end
        
        function InitFigure(obj)
            fig = figure('Name', 'Set Amplifiers',...
                'Visible', 'off', ...
                'NumberTitle', 'off', ...
                'Units', 'Pixels',...
                'MenuBar', 'None', ...
                'Color', get(0,'defaultUicontrolBackgroundColor'),...
                'KeyPressFcn', @(src,event)GuiLayout.CloseToEscapeCallback(event), ...
                'WindowStyle', 'modal');
            
            obj.AmpSetters = CAmpSetter.empty(0,1);
            for iAmp = 1 : length(obj.Amps)
                obj.AmpSetters(iAmp) = CAmpSetter(fig, obj.Amps(iAmp), obj.Channels);
            end
            
            Layout = cell(length(obj.Amps),1);
            for iAmp = 1 : length(obj.Amps)
                Layout{iAmp} = {obj.AmpSetters(iAmp).hPanel, [0 0]};
            end
            GuiLayout.ApplyLayout(fig, Layout);
            GuiLayout.MoveGuiRel(fig, 'cursor');
            movegui(fig, 'onscreen');
            set(fig, 'visible', 'on');
        end
    end
end
