classdef CTrigger < handle & CCopyableObject
    %CTRIGGER  NiHu.Lab class for trigger settings

    properties (SetObservable = true)
        trigLevel   % Trigger Level [V]
        preTrigTime % Pretrigger Time [s]
        status
    end
    
    methods
        function obj = CTrigger(triglevel, pretrigtime)
            if nargin < 2
                obj.preTrigTime = 1e-2;
            else
                obj.preTrigTime = pretrigtime;
            end
            
            if nargin < 1
                obj.trigLevel = 1;
            else
                obj.trigLevel = triglevel;
            end
            obj.status = 'idle';
        end
        
        function initialize(obj)
            obj.status = 'init';
        end
        
        function arm(obj)
            obj.status = 'armed';
        end
        
        function measure(obj)
            obj.status = 'measuring';
        end
        
        function reset(obj)
            obj.status = 'idle';
        end
    end
end
