#ifndef CALIBRATOR_H
#define CALIBRATOR_H

#include "Device.h"
#include "Serialisable.h"
#include "Quantity.h"

class CCalibrator : public CDevice
{
	CQuantity quantity;
	double frequency;
	double level;

public:
	CCalibrator(const string &vendor = "", const string &model = "", unsigned serialNumber = 0, const CQuantity &quantity = CQuantity::Voltage, double frequency = 0.0, double level = 0.0)
		: CDevice(vendor, model, serialNumber),
		  quantity(quantity),
		  frequency(frequency),
		  level(level)
	{
	}

	double getFrequency(void) const { return frequency; }
	double getLevel(void) const { return level; }
	const CQuantity &getQuantity(void) const { return quantity; }

	std::istream &serialise(std::istream &is);
	std::ostream &serialise(std::ostream &os) const;
};

#endif
