#ifndef DEVICE_H
#define DEVICE_H

#include "Serialisable.h"

#include <string>
using std::string;

class CDevice : public CSerialisable
{
	string vendor;
	string model;
	unsigned serialNumber;

public:
	CDevice(const string &vendor = "", const string &model = "", unsigned serialNumber = 0)
		: vendor(vendor),
		  model(model),
		  serialNumber(serialNumber)
	{
	}

	// This copy constructor is needed because of the abstract base class CSerialisable
	// Here we intentionally omit calling the base's hidden private copy constructor
	CDevice(const CDevice &other)
		: vendor(other.vendor),
		  model(other.model),
		  serialNumber(other.serialNumber){};

	virtual ~CDevice(void) {}

	const string &getVendor(void) const { return vendor; }
	void setVendor(const string &vendor) { this->vendor = vendor; }
	const string &getModel(void) const { return model; }
	void setModel(const string &model) { this->model = model; }
	unsigned getSerialNumber(void) const { return serialNumber; }
	void setSerialNumber(unsigned serialNumber) { this->serialNumber = serialNumber; }

	virtual std::istream &serialise(std::istream &is);
	virtual std::ostream &serialise(std::ostream &is) const;
};

#endif
