#ifndef QUANTITY_H
#define QUANTITY_H

#include "Serialisable.h"

#include <iostream>
#include <iomanip>

class CQuantity : public CSerialisable
{
public:
	typedef enum
	{
		Voltage,
		Acceleration,
		Pressure,
		Force
	} quantity_t;

private:
	static char const *const EUs[];
	static quantity_t const Quants[];

	quantity_t quantity;

public:
	CQuantity(const quantity_t &quantity = Voltage)
		: quantity(quantity) {}

	// Copy constructor needed because of abstract base class CSerialisable
	CQuantity(const CQuantity &other)
		: quantity(other.quantity) {}

	const quantity_t &getQuantity(void) const { return quantity; }
	void setQuantity(const quantity_t &quantity) { this->quantity = quantity; }

	std::istream &serialise(std::istream &is);
	std::ostream &serialise(std::ostream &os) const;
};

#endif
