#ifndef SERIALISABLE_H
#define SERIALISABLE_H

#include <iostream>

class CSerialisable
{
private:
	// Hidden copy constructor to avoid copying interface objects
	CSerialisable(const CSerialisable &);

public:
	// Default constructor needed because copy constructor has been disabled and
	// copy constructor of derived class has been defined
	CSerialisable() {}

	// virtual destructor to invoke derived destructor calls when CSerialisable is deleted
	virtual ~CSerialisable(void) {}

	// read from stream
	virtual std::istream &serialise(std::istream &is) = 0;
	// write to stream
	virtual std::ostream &serialise(std::ostream &os) const = 0;
};

std::istream &operator>>(std::istream &is, CSerialisable &s);
std::ostream &operator<<(std::ostream &os, const CSerialisable &s);

#endif
