clear;
clc;

fc = 50;
fs = 5000;
nSamples = fs;
type = 'uniform';
f = (0:nSamples-1)/nSamples*fs;

nReal = 1000;

betavec = -2 : 2;
nBeta = length(betavec);
S = zeros(nSamples, nBeta);
%%
for iBeta = 1 : nBeta
    
    %%
    beta = betavec(iBeta);
    
    %%
    w = zeros(nSamples, nReal);
    for i = 1 : nReal
        w(:,i) = colornoise(fs, nSamples, beta, type, fc);
    end
    
    %%
    W = fft(w, [], 1)/nSamples;
    S(:,iBeta) = mean(abs(W).^2, 2);
end
%%
figure;
formatfig;
font_size(14);
line_width(1);
loglog(f, S);
xlim([10, fs/2]);
ylim([1e-7, 1e-2]);
xlabel('Frequency [Hz]');
ylabel('Power Spectral Density [V^2]');
legend({'\beta = -2, (red)', '\beta = -1, (pink)', '\beta = 0, (white)', '\beta = 1, (blue)', '\beta = 2, (purple)'}, 'location', 'southeast');


print -depsc noises