function [A, gamma] = expfit(x, fs)
%EXPFIT  Fit exponential function
%   [A, GAMMA] = EXPFIT(X, FS) Fits an exponential function to each
%   column of X in the form
%   X = A * exp(GAMMA * t)

A = zeros(1, size(x,2));
gamma = zeros(1, size(x,2));
for i = 1 : size(x,2)
    z = x(1:end-1,i) \ x(2:end,i);
    gamma(i) = log(z) * fs;
    A(i) = z.^((0:size(x,1)-1)') \ x(:,i);
end
end
