classdef Reportable
    methods
        function s = sum(this)
            %SUM
            if ~isempty(this)
                s = this(1);
                for i = 2 : numel(this)
                    s = s + this(i);
                end
            else
                s = this;
            end
        end
        
        function c = count(this)
            c = numel(this);
        end
        
        function m = mean(this)
            %MEAN
            m = sum(this) ./ count(this);
        end
        
        function v = var(this)
            %VAR Variance
            v = mean(this.^2) - mean(this).^2;
        end
        
        function s = std(this)
            %STD Standard deviation
            s = var(this).^.5;
        end
        
        function c = cov(this, theother)
            %COV Covariance
            c = mean(this.*theother)-mean(this).*mean(theother);
        end
        
        function c = corr(this, theother)
            %CORR Correlation coefficient
            c = cov(this, theother) ./ (std(this).*std(theother));
        end
    end
    
    methods (Static)
        function ps = pivsum(p)
            for i = 1 : numel(p)
                ps(i) = sum(p{i});
            end
            ps = reshape(ps, size(p));
        end
    end
end