function x = soundsignal(mel, fs, Ts)
%SOUNDSIGNAL Generate Sound Signal
%   X = SOUNDSIGNAL(MEL, FS, T) generates NiHu.Lab melodies.
%
% Example
%   x = soundsignal('mav', 8000, .1);
%   soundsc(x, 8000);
%
%   y = soundsignal('mekk', 8000, .1);
%   soundsc(y, 8000);
%
% See also SOUND SOUNDSC AUDIOPLAYER


% Copyright 2010-2010 Peter Fiala

switch mel
    case 'mav'
        melody = [
            0, 0, 0, 0, 0, 0, 8, 0, 5
            8, 0, 5, 6, 5, 0, 3, 4, 3
            ];
    case 'mekk'
        melody = [
            2, 3, 5, 8
            ];
end

a = 3;
T = Ts*size(mel,2)+1.5;
freq = 440/5*3*5/4*[1 9/8 5/4 4/3 3/2 5/3 15/8 2];
t = (0:T*fs-1)/fs;
x = zeros(size(t));

for i = 1 : size(melody,2)
    tstart = (i-1)*Ts;
    tt = t(t>tstart) - tstart;
    for j = 1 : size(melody,1);
        m = melody(j,i);
        if m ~= 0
            x(t > tstart) = x(t>tstart) + sin(2*pi*freq(m)*tt).*exp(-a*tt);
        end
    end
end

x = x / max(abs(x));
end