function [Center, Y3] = spectrum2third(f, y)

Centres = 1000 * 2.^(-100/3:1/3:100/3);
low = Centres/2^(1/6);
high = Centres*2^(1/6);
nC = length(low);

filled = false(size(low));

s = size(y);
y = reshape(y, s(1), []);

Y = zeros(nC, size(y,2));

for iC = 1 : nC
    sel = f >= low(iC) && f < high(iC);
    if length(find(sel)) < 5
        continue;
    end
    
    Y(iC,:) = sum(abs(y(sel,:)).^2, 1)
    
    filled(iC) = true;
end

Y = Y(filled, :);
Centres = Centres(filled);

s(1) = size(Y,1);
Y = reshape(Y, s);

end
